<?php


/**
 * @param \Ramsalt\OAuth2\Client\Provider\ConnectId $connectid
 * @param \League\OAuth2\Client\Token\AccessToken $token
 *
 * @return bool|\League\OAuth2\Client\Provider\ResourceOwnerInterface
 */
function _connectid_api_service__profile(\Ramsalt\OAuth2\Client\Provider\ConnectId $connectid, \League\OAuth2\Client\Token\AccessToken $token) {
  $profile = FALSE;

  try {
    $profile = $connectid->getResourceOwner($token);
  }
    /** @noinspection PhpRedundantCatchClauseInspection */
  catch (\Ramsalt\OAuth2\Client\Provider\Exception\InvalidGrantException $exception) {
    watchdog(
      'connectid',
      'Invalid grant reported. Token: %token, Refresh: %refresh',
      [
        '%token'  => $token->getToken(),
        '%refresh'  => $token->getRefreshToken(),
      ],
      WATCHDOG_WARNING
    );
  }
    /** @noinspection PhpRedundantCatchClauseInspection */
  catch (\Ramsalt\OAuth2\Client\Provider\Exception\InvalidAccessTokenException $exception) {
    watchdog(
      'connectid',
      'Token %token reported as expired. Expire time was: @expire',
      [
        '%token'  => $token->getToken(),
        '@expire' => date('r', $token->getExpires()),
      ],
      WATCHDOG_NOTICE
    );
  }
    /** @noinspection PhpRedundantCatchClauseInspection */
  catch (\League\OAuth2\Client\Provider\Exception\IdentityProviderException $exception) {
    watchdog(
      'connectid',
      'Unhandled server error: !code. Message: %message',
      [
        '!code'    => $exception->getCode(),
        '%message' => $exception->getMessage(),
      ],
      WATCHDOG_ERROR
    );
  }

  return $profile;
}

/**
 * @param \Ramsalt\OAuth2\Client\Provider\ConnectId $connectid
 * @param \League\OAuth2\Client\Token\AccessToken $token
 *
 * @return bool|array
 */
function _connectid_api_service__product(\Ramsalt\OAuth2\Client\Provider\ConnectId $connectid, \League\OAuth2\Client\Token\AccessToken $token){

  $response = $connectid->getApiCustomerProduct($token);

  return $response;
}
